# include "std.h"
# if LICENCE
   This file is part of cwrite.
   Copyright 2007, Desislav Georgiev.
 
   cwrite is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
 
   cwrite is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
 
   You should have received a copy of the GNU General Public License
   along with cwrite.  If not, see <http://www.gnu.org/licenses/>.
# endif
# if HEADER
   # include <stdlib.h>
   # include <stdio.h>

   # include "bookmark.h"
   # include "cwrite.h"
   # include "datachain.h"
   # include "message.h"
   # include "status_line.h"
   # include "screen.h"
# endif

void bookmark_add()
   { int bookmark_ordinal = _datasystem->bookmark_ordinal;
     if ( bookmark_ordinal == BOOKMARK_CARDINAL )
       { status_line_print(_message[28]);
         return;
       }
     Bookmark * _bookmark_new = & _datasystem->bookmark[bookmark_ordinal++];
     _datasystem->bookmark_ordinal++;
     _bookmark_new->status = 1;
     _bookmark_new->_datachain = _datasystem->_datachain;
     _bookmark_new->dataline_offset = _datasystem->dataline_offset;
     _bookmark_new->cursor_y = * _cursor_y;
     _bookmark_new->cursor_x = * _cursor_x;
     status_line_vprintf(_message[30], bookmark_ordinal);
     return;
   }
void bookmark_goto(int bookmark_id)
   { int bookmark_ordinal = _datasystem->bookmark_ordinal;
     if ( bookmark_id >= bookmark_ordinal )
        { status_line_vprintf(_message[29], bookmark_id+1);
          return;
        }
     Bookmark * _bookmark = & _datasystem->bookmark[bookmark_id];
     if ( ! _bookmark->status )
         { status_line_vprintf(_message[29], bookmark_id+1);
           return;
         }
     _datasystem->_datachain = _bookmark->_datachain;
     _datasystem->dataline_offset = _bookmark->dataline_offset;
     * _cursor_y = _bookmark->cursor_y;
     * _cursor_x = _bookmark->cursor_x;
     status_line_vprintf(_message[31], bookmark_id+1);
     screen_redraw();
     return;
  }
void bookmark_clear()
   { _datasystem->bookmark_ordinal = 0;
     status_line_print(_message[32]);
     return;
   }
void bookmark_remove(Datachain * _datachain)
   { Bookmark * _bookmark;
     int bookmark_cardinal = _datasystem->bookmark_ordinal;
     for (int i = 0; i < bookmark_cardinal; i++)
        { _bookmark = & _datasystem->bookmark[i];
          if ( _bookmark->_datachain == _datachain )
             { _bookmark->status = 0;
             }
        }
     return;
   }
