# ifndef COMMAND_LINE_H
   # define COMMAND_LINE_H

   # include "history.h"

   # define COMMAND_LINE_STRINGS
   #  ifdef COMMAND_LINE_STRINGS
      extern char * _confirm_str[];
      extern char * _search_rstr[];
      extern char * _set_str[];
      extern char * _color_theme_str[];
      extern char * _syntax_str[];
      extern char * _lf_str[];

      extern int set_cardinal;
      extern int syntax_cardinal;
      extern int lf_cardinal;
   # endif

   # define REPLY_CANCEL -1
   # define REPLY_YES     0
   # define REPLY_NO      1

   # define SEARCH_REPLACE_YES 0
   # define SEARCH_REPLACE_NO  1
   # define SEARCH_REPLACE_ALL 2

      // -- command line parameters --
   extern char * _command_line;
   extern char * _entry_line;
   extern char * _entry_line_keep;

   extern int command_line_stop;
   extern int command_line_size;
   extern int entry_line_memsize;

   extern void entry_line_init();
   extern void command_line_init();

   extern void command_line_echo(char * _str);

   extern void command_line_print(char * _template, ...);
   extern void command_line_stop_print(char * _template, ...);

   extern void command_line_redraw();

   extern void command_line_clear();
   extern void command_line_back_to_stop();
   extern void command_line_backspace();

   extern void command_line_enter();

   extern void command_line_read(History * _history);
   extern void command_line_read_number();
   extern void command_line_read_lock();

   extern int command_line_revolve(char * _revolve_str[], int start, int n);
# endif
